package jeliot.lang;

import jeliot.parser.*;
import jeliot.theatre.*;

/**
  * @author Pekka Uronen
  *
  * created 30.9.1999
  */
public class ArrayLengthPointer extends FieldPointer {

    private ArrayType arrayType;

    public ArrayLengthPointer(ArrayType type) {
        this.arrayType = arrayType;
    }
    
    /** Returns the type of this field.
      */
    public Type getType() {
        return PrimitiveType.intTYPE;
    }
    
    /** 
      */
    public Type getDeclaringClass() {
        return arrayType;
    }
    
    /** Returns true if this field is declared as static.
      */
    public boolean isStatic() {
        return false;
    }
    
    /** Returns true if this is a private field.
      */
    public boolean isPrivate() {
        return false;
    }
    
    /** Returns true if this is a final field.
      */
    public boolean isFinal() {
        return true;
    }
    
    /** Returns the return value of the field.
      */
    public Variable access(Director dir) {
        return null;
    }
    
}
