package jeliot.lang;

import java.util.*;
import jeliot.parser.*;

/**
  * @author Pekka Uronen
  *
  * created         27.9.1999
  */
public class VoidType extends Type {
    
    public static VoidType voidTYPE = new VoidType();
    
    private VoidType() { }
    
    /** Checks if a value of this type may be assigned to a variable of
      * given type t.
      */
    public boolean mayBeAssignedTo(Type t) {
        return false;
    }
    
    /** Checks if a value of this type can be cast to a value of type
      * t in an explicit cast. If 
      */
    public boolean mayBeCastTo(Type t) {
        return false;
    }
    
    public String toString() {
        return "void";
    }
    
}