package jeliot.parser.error;

import java.util.*;
import jeliot.lang.*;
import jeliot.parser.*;

/**
  * IllegalArrayIndexException is thrown when a type checker finds that
  * a array is being indexed by an expression valued non-integral or
  * long.
  * 
  * @author Pekka Uronen
  *
  * created         30.9.1999
  */
public class IllegalArrayIndexException extends SemanticException {
    
    private PArrayAccess access;
    private Type type;
    
    public IllegalArrayIndexException(Type t, 
            PArrayAccess access) {
        
        this.access = access;
        this.type = t;
    }
    
    public String toString() {
         String typeStr = type.toString();
         String varName = access.getIdentifier();
        
         return (
            "<HTML><HEAD><TITLE>XXX</TITLE></HEAD>\n" +
            "<BODY bgcolor=white>" +
            "<H1>Illegal array index.</H1>\n" +
            "<P>" +
            "Your program tries to use a value of type of" +
            "<B>" + typeStr + "</B> " +
            "as an array index. This is not a good thing. "+
            "</BODY></HTML>"
            );
    }
    
}