package jeliot.script.jeliot.io;

import java.awt.*;
import jeliot.theatre.*;

/**
  * @author Pekka Uronen
  *
  * created         2.10.1999
  */
public class Output {

    public static Animator println(int xxx) {
        return new OutputAnimator(
            new Outputter() {
                String output(Object object) { 
                    return  ((Number)object).intValue() + "\n";
                }
            }
        );    
    }
    
    public static Animator println(double xxx) {
        return new OutputAnimator(
            new Outputter() {
                String output(Object object) { 
                    return  ((Number)object).doubleValue() + "\n";
                }
            }
        );    
    }
    
    public static Animator println(float xxx) {
        return new OutputAnimator(
            new Outputter() {
                String output(Object object) { 
                    return  ((Number)object).floatValue() + "\n";
                }
            }
        );    
    }
    
    public static Animator println(long xxx) {
        return new OutputAnimator(
            new Outputter() {
                String output(Object object) { 
                    return  ((Number)object).longValue() + "\n";
                }
            }
        );    
    }
    
    public static Animator println(boolean xxx) {
        return new OutputAnimator(
            new Outputter() {
                String output(Object object) {
                    return object+ "\n";
                }
            }
        );    
    }
    
    private abstract static class Outputter {    
        abstract String output(Object object);
    }
    
    private static class OutputAnimator extends Animator {
        
        Outputter putter;
        
        public OutputAnimator(Outputter putter) {
            this.putter = putter;
        }
        
        public void animate(Director director) {
            ActorFactory factory = director.getFactory();
            Theatre theatre = director.getTheatre();
            TheatreManager manager = director.getManager();
            AnimationEngine engine = director.getEngine();
            
            Actor actor = getArgumentActor(0);
            AnimatingActor hand = factory.produceHand();
            Point dest = manager.getOutputPoint();
            Point handp = new Point(dest.x, dest.y - hand.getHeight());
            Point vdp = new Point(dest.x + hand.getWidth()/3, 
                                  dest.y - hand.getHeight()*2/3);  
            Animation fist = hand.changeImage(
                    factory.produceImage("Fist-1"));
            fist.setDuration(800);
            
            theatre.capture();
            
            hand.setLocation(dest);
            engine.showAnimation(new Animation[] {
                    actor.fly(vdp),
                    hand.fly(handp, 0),
                    fist
                    });
            hand.setImage(factory.produceImage("Fist-2"));
            theatre.removeActor(actor);
            engine.showAnimation(hand.fly(dest,0));
            
            theatre.removeActor(hand);
            
            theatre.release();               
            
            director.output(putter.output(getArgument(0).getValue()));
            
        }
    }
        
}
